(define-module (goof helpers)
  #:export (define-aux-syntax define-aux-syntaxes))

(define-syntax define-aux-syntax
  (lambda (stx)
    (syntax-case stx ()
      ((_ name)
       #'(define-syntax name
           (lambda (stx)
             (syntax-violation 'name "Loop clause used outside of loop macro" stx)))))))
(define-syntax-rule (define-aux-syntaxes name ...)
  (begin
    (define-aux-syntax name) ...))
